package com.example.xmltest;

import java.io.IOException;
import java.net.URL;
import java.net.URLClassLoader;

import javax.xml.transform.Source;
import javax.xml.transform.stream.StreamSource;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Validator;

import org.junit.BeforeClass;
import org.junit.Test;
import org.xml.sax.SAXException;

public class SchemaValidationTest {
    @BeforeClass
    public static void showSystemClasspath() {
        ClassLoader sysClassLoader = ClassLoader.getSystemClassLoader();

        //Get the URLs
        URL[] urls = ((URLClassLoader)sysClassLoader).getURLs();

        System.out.println("System classpath:");
        for(int i=0; i< urls.length; i++) {
            System.out.println("\t" + urls[i].getFile());
        }       
    }
    
    @Test
    public void validateSchemaSimple() throws Exception {
        validate("simpleWithAssert.xsd", "simpleTest.xml");
    }

    @Test
    public void validateSchemaWithoutOnePointOneFeatures() throws Exception {
        validate("simpleWithoutAssert.xsd", "simpleTest.xml");
    }
    
    private void validate(String schemaDocumentName,
            String instanceDocumentName) throws SAXException,
            IOException {
        StreamSource schemaDocument = new StreamSource(getClass().getResourceAsStream(schemaDocumentName));
        SchemaFactory schemaFactory = SchemaFactory.newInstance("http://www.w3.org/XML/XMLSchema/v1.1");
        Schema schema = schemaFactory.newSchema(schemaDocument);
        Validator validator = schema.newValidator();
        
        Source instanceDocument = new StreamSource(getClass().getResourceAsStream(instanceDocumentName));
        validator.validate(instanceDocument);
    }
    
}
